/*******************************************************************************
 * Licensed Materials - Property of IBM
 *
 * com.ibm.xtools.rmps.web.core
 *
 * Copyright IBM Corporation 2015. All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("rmps.core.oslc_config.OslcConfig");

dojo.require("rmps.core.resource.Resource");

dojo.declare("rmps.core.oslc_config.OslcConfig", rmps.core.resource.Resource, {

	/**
	 * The title of the configuration
	 */
	title: null,
	
	/**
	 * The URI of the user that created this configuration.
	 */
	creator: null,

	/**
	 * The date and time that this configuration was created.
	 * The expected format is ISO8601.
	 */
	created: null,
	createdISO8601: null,
	
	/**
	 * The description of the configuration
	 */
	description: null,
	
	parseEntry: function(entry, ioArgs) {
		var configNode = entry.content[0]["rdf:RDF"][0]["rdf:Description"][0];

		this.parse(configNode);
	},

	parse: function(configNode) {
		this.uri = configNode["rdf:about"];
		
		// title
		this.title = configNode["dcterms:title"][0].value;
		
		// creator
		this.creator = configNode["dcterms:creator"][0]["rdf:resource"];

		// created
		this.createdISO8601 = configNode["dcterms:created"][0].value;
		this.created = dojo.date.stamp.fromISOString(this.createdISO8601);
		
		// description
		if (configNode["dcterms:description"]) {
			this.description = configNode["dcterms:description"][0].value;			
		}
	}
});

}());