/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2013, 2014, 2015.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/

(function(){

dojo.provide("com.ibm.xtools.rmps.web.deliver.server.core.ui.internal.deliver.DeliverSummaryStep");

dojo.require("dijit/form/RadioButton");

dojo.require("jazz.ui.wizard.WizardStep");
var WizardStep = jazz.ui.wizard.WizardStep;

dojo.require("com.ibm.xtools.rmps.web.deliver.shared.web.ui.VvcConstants");
var VvcConstants = com.ibm.xtools.rmps.web.deliver.shared.web.ui.VvcConstants;

dojo.require("com.ibm.xtools.rmps.web.deliver.shared.core.ui.objects.Constants");
var Constants = com.ibm.xtools.rmps.web.deliver.shared.core.ui.objects.Constants;

dojo.require("com.ibm.team.repository.web.configurationManagement.cache.CmCache");
dojo.require("com.ibm.team.repository.web.configurationManagement.CmConstants");
dojo.require("com.ibm.team.repository.web.configurationManagement.cache.CmCacheFactory");

dojo.require("jazz.ui.StyledBox");
dojo.require('jazz.ui.Select');
dojo.require("dijit.form.Button");
dojo.require("dojo.DeferredList");

dojo.requireLocalization("com.ibm.xtools.rmps.web.deliver.server.core.ui.internal.deliver", "DeliverSummaryStepMessages");

var CmCacheFactory = com.ibm.team.repository.web.configurationManagement.cache.CmCacheFactory;

/**
 * Wizard step that allows the user view a summary of the operation that will
 * be performed. Note that this step will not be shown for compare operations.
 */
dojo.declare("com.ibm.xtools.rmps.web.deliver.server.core.ui.internal.deliver.DeliverSummaryStep", [WizardStep, dijit._Widget, dijit._Templated], {
	
	messages : dojo.i18n.getLocalization("com.ibm.xtools.rmps.web.deliver.server.core.ui.internal.deliver", "DeliverSummaryStepMessages"),	
	templateString: dojo.cache('com.ibm.xtools.rmps.web.deliver.server.core', 'ui/internal/deliver/templates/DeliverSummaryStep.html'),
	widgetsInTemplate: true,
	
	/**
	 * The session
	 */
	session: null,
	
	_cache: null,
			
	/**
	 * Arguments:
	 * - session: DeliverSession.js object
	 */
	constructor: function(args){
		this._cache = CmCacheFactory.getConfigurationCache();
		
		if (args) {
			if (args.session) {
				this.session = args.session;
			}
			if (args.wizardApp) {
				this.wizardApp = args.wizardApp;
			}
		}
		
		this.stepTitle = this.messages.finalStepTitle;
	},
	
	postCreate: function() {
		this.reload();
	},
	
	reload: function() {
		var sourceUri = this.session.getSourceUri();
		if (sourceUri) {
			dojo.when(this._cache.get(sourceUri), dojo.hitch(this, function(config){
				dojo.addClass(this.sourceIconNode, "icons-" + config.type);
				this.sourceNode.innerHTML = config.name;
			}));
		}
		
		var targetUri = this.session.getTargetUri();
		if (targetUri) {
			dojo.when(this._cache.get(targetUri), dojo.hitch(this, function(config){
				dojo.addClass(this.targetIconNode, "icons-" + config.type);
				this.targetNode.innerHTML = config.name;
			}));
		}
	},
	
	onFinish: function() {
		this.session.setCommitChangeSet(true);
		this.wizardApp.updateSession(this.session, this);
		this.wizardApp.performFinish();
	},
	
	canFinish: function() {
		return true;
	},
});

})();