/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2013, 2014, 2015. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("com.ibm.xtools.rmps.web.deliver.server.core.ui.internal.deliver.DeliverWizardApplication");

dojo.require("jazz.ui.Wizard");
var Wizard = jazz.ui.Wizard;

dojo.require("jazz.ui.wizard.WizardStep");
var WizardStep = jazz.ui.wizard.WizardStep;

dojo.require("com.ibm.team.repository.web.ui.internal.admin.NotAuthorizedView");
var NotAuthorizedView = com.ibm.team.repository.web.ui.internal.admin.NotAuthorizedView;

dojo.require("com.ibm.xtools.rmps.web.deliver.shared.core.ui.objects.DeliverSession");
var DeliverSession = com.ibm.xtools.rmps.web.deliver.shared.core.ui.objects.DeliverSession;

dojo.require("com.ibm.xtools.rmps.web.deliver.server.core.ui.internal.deliver.SourceTargetPickerStep");
var SourceTargetPickerStep = com.ibm.xtools.rmps.web.deliver.server.core.ui.internal.deliver.SourceTargetPickerStep;

dojo.require("com.ibm.xtools.rmps.web.deliver.server.core.ui.internal.deliver.DeliverSummaryStep");
var DeliverSummaryStep = com.ibm.xtools.rmps.web.deliver.server.core.ui.internal.deliver.DeliverSummaryStep;

dojo.require("com.ibm.xtools.rmps.web.deliver.server.core.ui.internal.deliver.ChangesetPickerStep");
var ChangesetPickerStep = com.ibm.xtools.rmps.web.deliver.server.core.ui.internal.deliver.ChangesetPickerStep;

dojo.require("jazz.ui.wizard.ExternalWizardStep");
var ExternalWizardStep = jazz.ui.wizard.ExternalWizardStep;

dojo.require("com.ibm.xtools.rmps.web.deliver.shared.core.ui.objects.Constants");
var Constants = com.ibm.xtools.rmps.web.deliver.shared.core.ui.objects.Constants;

dojo.require("com.ibm.xtools.rmps.web.deliver.shared.web.ui.notifications.notificationCenterController.VvcNotificationCenterController");
var VvcNotificationCenterController = com.ibm.xtools.rmps.web.deliver.shared.web.ui.notifications.notificationCenterController.VvcNotificationCenterController;

dojo.require("com.ibm.xtools.rmps.web.deliver.shared.web.ui.notifications.notifications.VvcNotificationFactory");
var ncFactory = com.ibm.xtools.rmps.web.deliver.shared.web.ui.notifications.notifications.VvcNotificationFactory;

dojo.require("com.ibm.xtools.rmps.web.deliver.shared.core.ui.utils.ErrorUtil");
var ErrorUtil = com.ibm.xtools.rmps.web.deliver.shared.core.ui.utils.ErrorUtil;

dojo.require("com.ibm.xtools.rmps.web.deliver.server.core.ui.internal.deliver.DeliverUtil");
var DeliverUtil = com.ibm.xtools.rmps.web.deliver.server.core.ui.internal.deliver.DeliverUtil;

dojo.require("com.ibm.xtools.rmps.web.deliver.shared.web.ui.util.InfoContentUtils");
var InfoContentUtils = com.ibm.xtools.rmps.web.deliver.shared.web.ui.util.InfoContentUtils;

dojo.require("com.ibm.xtools.rmps.web.deliver.shared.web.ui.util.VvcUtils");
var VvcUtils = com.ibm.xtools.rmps.web.deliver.shared.web.ui.util.VvcUtils;

dojo.require("com.ibm.team.repository.web.configurationManagement.cache.CmCacheFactory");
var CmCacheFactory = com.ibm.team.repository.web.configurationManagement.cache.CmCacheFactory;

dojo.require("com.ibm.xtools.rmps.web.deliver.server.core.ui.internal.deliver.InterimResultClient");
var InterimResultClient = com.ibm.xtools.rmps.web.deliver.server.core.ui.internal.deliver.InterimResultClient;

dojo.require("jazz.util.browserSupport");
dojo.require("jazz.app.auth");
dojo.require("jazz.ui.UnsupportedBrowserWarning");


dojo.require("dojo.i18n");
dojo.requireLocalization("com.ibm.team.repository.web.ui.internal.wizard", "WizardApplicationMessages");
dojo.requireLocalization("com.ibm.xtools.rmps.web.deliver.server.core.ui.internal.deliver", "DeliverWizardApplicationMessages");

var VVC_CONFIGURATION = "vvc.configuration";
var VVC_OSLC_CONFIGURATION = "oslc.configuration";

/**
 * Strips a url of its query parameters and hash. 
 * @param  {String} url The URL to be stripped
 * @return {String}     URL without query parameters and hash
 */
function stripUrl(url) {
	return url.split(/[?#]/)[0];
}

function redirectToUriOrDocumentReferrer(uri) {
     document.location.href = (uri || document.referrer);
}

function preloadSpinner() {
    // Summary:
    //    Because the "Finish" button redirects the browser by setting
    //    document.location.href, any pending image loads are cancelled.
    //    This means that the spinner which is set to the left of the
    //    green label shows a broken link icon.  I assume that the browser
    //    does not bother to GET the image when a redirect is in process, or
    //    the redirect will cancel the loading. So here we load the image
    //    so the browser doesn't have to GET it when we add it to the DOM right
    //    before the redirect.
    
    var spinner = new Image();
    // set the src attribute, this causes the browser to actually go and get the image
    spinner.src = dojo.moduleUrl("com.ibm.xtools.rmps.web.deliver", "server/core/ui/internal/wizard/images/loading_obj.gif");
    
    return spinner;
}

/**
 * Wizard application that launches the full-screen deliver UI. The wizard adapts itself
 * to be used as for deliver, compare or rebase operations.
 */
dojo.declare("com.ibm.xtools.rmps.web.deliver.server.core.ui.internal.deliver.DeliverWizardApplication", [ dijit._Widget ], {
	
	messages: dojo.i18n.getLocalization("com.ibm.xtools.rmps.web.deliver.server.core.ui.internal.deliver", "DeliverWizardApplicationMessages"),
	
	step1: null,
	step2: null,
	finalStep: null,
	session: null,
	loadingLabel: null,
	notificationCenter: null,
	
	isExpectedPageRedirect: null,
	referrerUri: null,
	title: null,
	
	constructor: function() {
		this.wizardMessages = dojo.i18n.getLocalization("com.ibm.team.repository.web.ui.internal.wizard", "WizardApplicationMessages");
	},
	
	_initializeParamsFromLocation: function() {
		var qstr = window.location.search.substr(1);
		if (qstr.length) {
			var qparts = qstr.split("&");
			for (var x = 0; x < qparts.length; x++) {
				var tp = qparts[x].split("=");
				if (tp[0] === "title") {
					this.title = decodeURIComponent(tp[1]);
				} else if (tp[0] === "referrer") {
					this.referrerUri = decodeURIComponent(tp[1]);
				} 
			}
		}	
	},
	
	postCreate: function() {
		this._checkBrowser();
		// read this as soon as we start up
		this._initializeParamsFromLocation();
		
		preloadSpinner();
		
		window.onbeforeunload = dojo.hitch(this, function(){
			if(!this.isExpectedPageRedirect 
					&& this.session 
					&& !this.session.isCompareOnly() 
					&& this.session.getState() !== Constants.DELIVER_SESSION_STATE_UNINITIALIZED
					&& this.session.getState() !== Constants.DELIVER_SESSION_STATE_FINISHED){
				return this.messages.confirmRedirect;
				
			}
		});
		
		window.onunload = dojo.hitch(this, function(){
			if(this.session){
			    /*
			     * Note [SW].  If you want to debug the compare UI, e.g have the ability
			     * to refresh the step you are on in the browser, you need to comment
			     * this out, otherwise the session will be deleted.
			     */
				this.endSession(this.session, /*keep sessions that weren't abandoned */!this._retainSession);
			}
		});
	},
	
	_checkBrowser: function() {
		//Check to see if we are using a supported Browser
		var support = jazz.util.browserSupport.getSupportLevel();
		if (support && (support == jazz.util.browserSupport.NOT_SUPPORTED)) {
			var warn = new jazz.ui.UnsupportedBrowserWarning();
			this.connect(warn, "onContinue", function() {
				warn.destroy();
				this._createUI();
			});
			warn.placeAt(document.body);
		} else {
			this._createUI();
		}
	},
	
	_createUI: function() {
		if (this.title) {
			jazz.app.currentApplication.ui.attr("bannerTitle", this.title);	
		}

		this.notificationCenter = new VvcNotificationCenterController();
		this.informationCenter = document.createElement("div");
		this.informationCenter.appendChild(this.notificationCenter.domNode);
		dojo.style(this.informationCenter, "padding", "0px 0px 10px");
		this.domNode.appendChild(this.informationCenter);

		this.getDeliverSession().then(dojo.hitch(this, function(session) {
			this.session = session;
		
			var title = this.messages.wizardName_deliver;
			if (this.session.isCompareOnly()) {
				title = this.messages.wizardName_compare;
			} else if (this.session.isRebase()) {
				title = this.messages.wizardName_rebase;
			}
						
			document.body.style.background = "none";
			document.title = title;
			this.content = dojo.create("div", { className: "com-ibm-team-repository-wizard" });
			dojo.addClass(this.domNode, "com-ibm-team-repository-web-setup-RootNode");
			
			var header = dojo.create("div", {className: "header", style: {zIndex: 7}}, this.content);
			dojo.create("h1", {
				"class": "operation-title",
				innerHTML: title
			}, header);
			
			var jazzIcon = dojo.create("img", { className: "jazz-icon", style: {zIndex: 7} }, this.content);
			jazzIcon.src = dojo.moduleUrl("com.ibm.xtools.rmps.web.deliver.server.core", "graphics/jazz-identR.png");
									
			this.wizardBox = dojo.create("div", {
				"class": "wizard-box"	
			}, this.content);
			
			
			if (this.session.isCompareOnly()) {
				this.finishCreatingUI(true);
			} else {
				var canMergeDeferred = com.ibm.xtools.rmps.web.deliver.shared.web.ui.util.SecurityServiceUtils.canMerge(this.session.getTargetUri());
				canMergeDeferred.then(dojo.hitch(this, function(result) {
					this.finishCreatingUI(result);
				}));
			}
		}));
	},
	
	_processRedirect: function() {
	    // Summary:
	    //     Handles redirecting the UI at the end of a deliver/compare session.
	    // 

    	redirectToUriOrDocumentReferrer(this.referrerUri);
	},
	
	getUnusedWizardSteps: function(/*[jazz.ui.wizard.WizardStep]*/steps) {
		// Summary:
		//		Returns a promise that resolves with an array of wizard steps
		//		that are not required for this deliver session, i.e. they can
		//		be removed from the list passed in.  
		//
		//		Removing them from the list here wont work in the case the steps
		//		are already registered with the Wizard which is why this function
		//		leaves it to the caller to remove the steps.
		//
		//		The process is to fetch the "Interim Results" and then to look 
		//		at the results for unused compare provider URIs in the supplied
		//		steps.
		//
		// steps:
		//		Array of jazz.ui.wizard.WizardSteps.
		// returns:
		//		A list of steps that are not required.
		
		return InterimResultClient.loadInterimResult(null, this.sessionUri)
			.then(function(interimResults) {
	            // Get the interim results entries, these are keyed by the "compareProvider"
	            // so we can easily get a list of the required steps from those keys.
	            var usedSteps = Object.getOwnPropertyNames(interimResults.entries);
	            // return any unused steps, to get this we need to implement the filter
	            // function such that it returns true if the step is *not* to be included
	            return steps.filter(function(s) {
	                if (typeof s.compareProviderUri === "undefined") {
	                    // if the step does not have a "compareProviderUri" property,
	                    // then assume that it's not an external step and will be used.
	                    return false;
	                } else {
	                    // otherwise, if it's not in the list of the compare providers
	                    // we don't need it.
	                    return usedSteps.indexOf(s.compareProviderUri) === -1;
	                }
	            });
	        })
	        .otherwise(dojo.hitch(this, function(response) {
	        	// show the locked artifacts message...
//	        	VVCCompareUtils.checkForLockedArtifactsError(response);
//	        	if (this.step1 && typeof this.step1.triggerButtonStateUpdate === "function") {
//	        		// disable the next button in the UI as well.
//	        		this.step1.canProceed = false;
//	        		this.step1.triggerButtonStateUpdate();
//	        	}
	        	
	        	return [];
	        }));
	},
	
	updateActiveCompareProviders: function() {
		// Summary:
		//		Removes any unused compare provider steps from the wizard.
		//		This function only needs to be called once the list of change
		//		sets has been selected during a stream -> stream delivery
		//		process.  This function is called from the ChangeSetPickerStep which
		//		is not present in the wizard if we are delivering a single change set.
		//		(see createSteps function below)		
		//
		//		Once the list of change sets has been selected, they can't be altered
		//		during the current session.
		//
		// returns:
		//		A promise that resolves when the unused wizard steps have been determined
		//		and removed from the wizard.  The promise resolves with no value.
		
//		var removeStep = dojo.hitch(this.wizard, this.wizard.removeStep);
//		this.showLoadingMessage();
//		return this.getUnusedWizardSteps(this.wizard.steps)
//			.then(dojo.hitch(this, function(unusedSteps) {
//				unusedSteps.forEach(removeStep);
//			}))
//			.always(dojo.hitch(this, this.hideLoadingMessage));
		var def = new dojo.Deferred();
		def.callback();
		return def;
	},
	
	finishCreatingUI: function(authorized) {
		
		if (authorized) { 
			this.createSteps().then(dojo.hitch(this, this._finishCreatingWizard));
		} else {
			
			var notAuthStep = new NotAuthorizedView({
					applicationName: document.title,
					customNoUserMessage: this.wizardMessages.userNotRecognizable,
					includeBackLink: false,
					showLogout: true });
			dojo.mixin(notAuthStep, new WizardStep());
			notAuthStep.includeNavigationUI = false;
			this._finishCreatingWizard([notAuthStep]);
		}
		
	},
	
	_finishCreatingWizard: function(steps) {
		var wizardParams = {
			fullPageContainer: this.wizardBox,
			stepListLayout: "horizontal",
			showStepSummary: false,
			
			processFinish: dojo.hitch(this, function(){
				this._processRedirect();
            }),
            includeCancel: true,
            headerNode: this.informationCenter
		};
		wizardParams.steps = steps;
		this.steps = wizardParams.steps;
		this.wizard = new Wizard(wizardParams);
		
		// deal with cancel on a wizard level
		this.wizard.contentWidget.processCancel = dojo.hitch(this, function() {
			this.isExpectedPageRedirect = true;
			this.showLoadingMessage();
			this.endSession(this.session, true, false).then(dojo.hitch(this, function() {
				// go back to the referer. 
				this._processRedirect();
          }));
		});
		
		var outerFooter = new com.ibm.team.repository.web.ui.internal.wizard.LogoFooter();
		this.content.appendChild(outerFooter.domNode);
		this.domNode.appendChild(this.content);
		this.repositionButtons();
		this.wizard.startup();
		
		this.hideLoadingMessage();
	},

	repositionButtons: function __repositionButtons() {
		var buttonArea = dojo.query('.buttonArea')[0];
		var headerArea = dojo.query('.header')[0];
		if (!buttonArea || !headerArea) {
			return;
		}
		var navArea = buttonArea.parentNode.parentNode;
		dojo.place(buttonArea, headerArea, "last");
		dojo.destroy(navArea);
		
	},
	
	createSteps: function() {		
		// Summary:
		//		Returns a promise that resolves with the steps for the wizard.
		//		If the source is a change set or we are doing a compare, then we
		//      can skip the change set picker step.
		//
		//		Note (WI:95451) even if there is only one change set to be delivered in
		//		a stream to stream scenario, we must still go through the change set
		//		selection step to properly initialise the deliver session.
		//
		//	returns:
		//		A Promise that resolves with an array of the wizard steps.
		//
		
		var isSourceConfigurationChangeset = dojo.hitch(this, function() {
			// Returns a a promise that resolves with true/false depending on
			// whether the source is a change set.
			return CmCacheFactory.getConfigurationCache().get(this.session.getSourceUri())
				.then(function(source) {
					// note that comparing to CmConstants.ConfigurationTypeLiterals.changeSet()
					// will not work here since the constant value is "changeset" vs "changeSet"...
					return source && (source.type === "changeSet");
			});
		});

		var createInitialSteps = dojo.hitch(this, function(sourceIsChangeSet) {
			var steps;
			this.finalStep = new DeliverSummaryStep({session: this.session, wizardApp: this});
			this.step2 = new ChangesetPickerStep({session: this.session, wizardApp: this});
			this.step1 = new SourceTargetPickerStep({session: this.session, wizardApp: this});
			this.sourceIsChangeSet = sourceIsChangeSet;
	
	        // Step 2 is the change set picker step, no point showing it for a compare
	        // or if the source is a change set.  
			if (!this.session.isCompareOnly() && !sourceIsChangeSet) {
				steps = [ this.step1, this.step2 ];
			} else {
				steps = [ this.step1 ];
			}
			return steps;
		});
	
		var createExternalSteps = dojo.hitch(this, function(steps) {
			return InterimResultClient.getCompareProviders(this.session.getUri()).then(dojo.hitch(this, function(providerList) {
				return this._createExternalSteps(providerList, this.session, steps);
			}));
		});
		
		var createFinalSteps = dojo.hitch(this, function(steps) {
			if (!this.session.isCompareOnly()) {
				steps.push(this.finalStep);
			}

			if (this.sourceIsChangeSet && !this.session.isCompareOnly()) {
				// if we're delivering a change set, then calculate what
				// steps are not required now, and remove those from our list
				// of steps. Note that if we're doing stream to stream delivery
				// the list of steps will be updated after the change set picker
				// step. Since that step doesn't exist when delivering a single
				// change set, we meed to work out the steps now.
//				this.showLoadingMessage();
//				return this.getUnusedWizardSteps(steps).then(dojo.hitch(this, function(unused) {
//					unused.forEach(function(step) {
//						steps.splice(steps.indexOf(step), 1);
//					});
//					
//					if (!this.session.isCompareOnly() && unused.length === RM_PROVIDER_LIST.length) {
//						// display a warning and disable the next button.
//						com.ibm.rdm.web.common.MessageHandler.showInfo(7852);
//						this.step1.canProceed = false;
//						// need to wait until the wizard is initialised and has selected a step
//						// before this will work.
//						setTimeout(dojo.hitch(this, this.step1.triggerButtonStateUpdate));
//					}
//					
//					return steps;
//				}));
				return steps;
			} else {
				return steps;
			}			
		});
		
		return isSourceConfigurationChangeset().
			then(createInitialSteps).
			then(createExternalSteps).
			then(createFinalSteps);
	},
		
	_createExternalSteps: function(providerList, session, steps) {
		this.sessionUri = session.getUri() + "/resources";
		var sessionUri = encodeURIComponent(this.sessionUri);
		var tempSteps = [];
		var delegatedWebUri;
		if (providerList && providerList.length > 0) {
			for (var i = 0; i < providerList.length; i++) {
				
				// Default
				delegatedWebUri = providerList[i].getCompareWebUri();
				
				var tmp;  // place holder incase we have merge URI
				if (!this.session.isCompareOnly() && providerList[i].hasSeparateMergeProvider()) {
					if ( (tmp = providerList[i].getMergeWebUri()) ) {
						delegatedWebUri = tmp; // use the merge web URI instead
					} else {
						// Default to VVC compare
						delegatedWebUri = DeliverUtil.getDefaultCompareMergeWebUri();
					}
				}

				var providerUri = providerList[i].getUri();
				if (delegatedWebUri) {
					var webUri = delegatedWebUri + 
						(djConfig.isDebug ? "&debug=true" : "") +
						"&provider=" + encodeURIComponent(providerUri);
						
					// TODO: compare operation?
					if (this.operation) {
						webUri += "&operation=" + this.operation;
					}
					
					if (sessionUri) {
						webUri += "&interimResultUri=" + sessionUri;
					}
					
					webUri += "#embed=true&s=/steps/1";
					var title = providerList[i].getTitle();
					var args = {
						displayName: title,
						stepURL: webUri
					};
					var step = new com.ibm.xtools.rmps.web.deliver.server.core.ui.internal.deliver.DeliverExternalWizardStep(args);
					step.title = title;
					step.compareOnly = session.isCompareOnly();
					step.compareProviderUri = providerList[i].getUri();
					step.wizardApp = this;
					step.ordering = providerList[i].getOrdering();
					tempSteps.push(step);
				}
			}
		}
		
		tempSteps.sort(this.stepsComparator);
		
		for (var i = 0; i < tempSteps.length; i++) {
			steps.push(tempSteps[i]);
		}
		return steps;
	},
	
	stepsComparator: function(a,b) {
		// Sort by ordering. Use title to break ties.
		var diff = a.ordering - b.ordering;
		if (diff !== 0)
			return diff;
		return a.title.localeCompare(b.title);
	},
	
	getDeliverSession: function() {
		var location = window.location.href;
		// change the deliverui to deliver path
		location = location.replace(Constants.DELIVER_UI_FRONT_SERVICE_PATH, Constants.DELIVER_FRONT_SERVICE_PATH);
		
		var queryStart = location.indexOf('?');
		if (queryStart < 0) {
			queryStart = location.length;
		}
		var hashStart = location.indexOf('#');
		if (hashStart < 0) {
			hashStart = location.length;
		}
		
		var endOfSegment = Math.min(queryStart, hashStart);
		
		var resourceNameStart = location.indexOf(Constants.DELIVER_FRONT_SERVICE_PATH) + Constants.DELIVER_FRONT_SERVICE_PATH.length;
		
		var resourceName = location.substring(resourceNameStart, endOfSegment);
		
		if (resourceName.length <= 1) { // account for the ending /
			window.location.replace(location.substring(0, resourceNameStart));
			return this._ensurePromise();
		} else {
			var session = new DeliverSession();
			this.showLoadingMessage();
			return session.loadAsync(location.substring(0, endOfSegment), /* onError */ dojo.hitch(this, function(response) {
				// this will just yield a 500 at the moment.
				setTimeout(dojo.hitch(this, this.showErrorMessage, response));
			}));		

		}
	},
	
	updateSession: function(session, excludeStep) {
		this.session = session;
		if (excludeStep !== this.step1) {
			if (session
					&& session.getState() !== Constants.DELIVER_SESSION_STATE_UNINITIALIZED) {
				this.step1.disableUi();
			}
		}
		
		if (excludeStep !== this.step2) {
			this.step2.session = session;
			this.step2.reload();
		}
		
		if (excludeStep !== this.finalStep) {
			this.finalStep.session = session;
			this.finalStep.reload();
		}
	},
	
	endSession: function(session, deleteSession, sync) {
		
		if (typeof sync === "undefined") {
			sync = true;
		}
		
		var url = session.getUri();
		if (deleteSession && !this._sessionDeleted) {
			return dojo.xhrDelete({
				url: url,
				sync: sync
			}).then(dojo.hitch(this, function() { this._sessionDeleted = true; }));
		}
	},
	
	showLoadingMessage: function(messageStr) {
		if (!messageStr) {
			messageStr = this.messages.loading;
		}
		
		this.hideLoadingMessage();
		
		this.loadingLabel = dojo.create("div", { innerHTML: "<div class='loadingDiv'><table width='100%'><tr><td align='center'>" +
				"<span class='loadingLabel'><img src='" + 
			dojo.moduleUrl("com.ibm.xtools.rmps.web.deliver", "server/core/ui/internal/wizard/images/loading_obj.gif") + 
			"' />&nbsp;&nbsp;" + messageStr +"</span></td></tr></table></div>", className: "loadingMask"}, dojo.body());
	},
	
	hideLoadingMessage: function() {
		if (this.loadingLabel) {
			dojo.destroy(this.loadingLabel);
			this.loadingLabel = null;
		}
	},
	
	showErrorMessage: function(response, ioArgs) {
		var notification = null;
		if (response) {
			if (response.status == 404) {
				if (this.session && this.session.isCompareOnly()) {
					notification = ncFactory.createError({
						title: this.messages.sessionTimeoutTitle_compare,
						description: this.messages.sessionTimeoutDescription,
						solution: this.messages.sessionTimeoutSolution_compare,
						closeOnEvent: response.closeOnEvent
					});
				} else {
					notification = ncFactory.createError({
						title: this.messages.sessionTimeoutTitle,
						description: this.messages.sessionTimeoutDescription,
						solution: this.messages.sessionTimeoutSolution,
						closeOnEvent: response.closeOnEvent
					});
				}
			} else {
				var errorDetails = ErrorUtil.getErrorDetails(response);
				if (errorDetails.errorSubStatus === "CANNOT_LOCK_NON_PARTIAL_CHANGESETS") {
					notification = ncFactory.createError({
						title: dojo.string.substitute(this.messages.cannotLockTitle, {resourceUrl: errorDetails.errorMessage}),
						description: this.messages.cannotLockDescription,
						solution: this.messages.cannotLockSolution,
						closeOnEvent: response.closeOnEvent
					});
				} else if (errorDetails.errorSubStatus === "CONFLICTS_REMAIN_NON_PARTIAL_CHANGESETS") {
					notification = ncFactory.createError({
						title: this.messages.conflictsRemainTitle,
						description: this.messages.conflictsRemainDescription,
						solution: this.messages.conflictsRemainSolution,
						closeOnEvent: response.closeOnEvent
					});	
				} else if (errorDetails.errorSubStatus === "CANNOT_DELIVER_TO_FLOW_TARGET_WITH_CONFLICTS") {
					notification = ncFactory.createError({
						title: this.messages.conflictsInFlowTargetTitle,
						description: this.messages.conflictsInFlowDescription,
						solution: this.messages.conflictsInFlowSolution,
						closeOnEvent: response.closeOnEvent
					});	
				}
			}
		}
		
		if (!notification) {
			ncFactory.createXhrError({
				xhrError: response, 
				ioArgs: ioArgs,
				closeOnEvent: response.closeOnEvent
			}).dispatch();
		} else {
			notification.dispatch();
		}
		
		this.hideLoadingMessage();
	},
	
	
	_swapChangeSetUriForParentInReferrerIfRequired: function() {
		
		// Summary:
		//	Replaces the vvc.configuration in the referrerURI (what this wizard redirects to)
		//	if the vvc.configuration in the URL is the source configuration of this session.
		//  Also replaces the oslc.configuration to a global GC if originally a personal GC.
		//
		//	This function is used at the end of a deliver in order to make sure we don't try and
		//  redirect back to the delivered change set.  The code checks whether this is a deliver
		//  before calling this function.
		//
		var args = dojo.queryToObject(this.referrerUri),
    	    previousConfiguration = args[VVC_CONFIGURATION],
    	    source = this.session.getSourceUri();
    	  		
		var switchContext = dojo.hitch(this, function(globalConfigurationURI) {
			if (globalConfigurationURI) {
				args[VVC_OSLC_CONFIGURATION] = globalConfigurationURI;
			}
			
			// OK, well we can't use that anymore, we should instead use 
	    	// the target that we delivered to as the new context.	    	
			args[VVC_CONFIGURATION] = this.session.getTargetUri();			
			
			// Not sure this is required any more....
    		CmCacheFactory.getConfigurationCache().clear(source);
    		CmCacheFactory.getChangeSetsCache().clear(source);     
    		this.referrerUri = decodeURIComponent(dojo.objectToQuery(args));
    	});
    	
    	
	     // first, see if the URL we need to redirect to had a configuration
	     // parameter in it, and whether that parameter is the source, i.e.
	     // are we delivering from the context we want to switch back to ?
	     if (previousConfiguration && previousConfiguration === source) {
	        // looks like it, so was it a change set that we just delivered ?
	        return CmCacheFactory
	        		.getConfigurationCache()
	            	.get(source)
                	.then(dojo.hitch(this, function(config) {
                		if (config.type === "changeSet") {
                			// LVFIXME
                			// If it's a change set in a personal GC,
                			// then after delivery, switch to the GC instead.
//                			if (args[VVC_OSLC_CONFIGURATION]) {
//                				RMVVCUtils.getGlobalConfigurationForPersonalConfiguration(args[VVC_OSLC_CONFIGURATION])
//                    			.then(function(globalConfigurationURI) {
//                    				switchContext(globalConfigurationURI);
//                				});                			                    			                				
//                			}
//                			else {
//                				switchContext();
//                			}
                			switchContext();
                    	} 
                	}))
                	.otherwise(function() { 
                		console.debug("Couldn't find changeSet in the cache...");
                	});
        } else {
        	return this._ensurePromise({});
        }
	},
	
	performFinish: function() {
		var previousState = this.session.getState();
		this.session.setState(Constants.DELIVER_SESSION_STATE_FINISHED);
		
		if (this.session.isCompareOnly()) {
			this.showLoadingMessage(this.messages.finishing_compare);
			this._processRedirect();
			return;
		} else if (this.session.isRebase()) {
			this.showLoadingMessage(this.messages.finishing_rebase);
		} else {
			this.showLoadingMessage(this.messages.finishing_deliver);
		}
		
		var self = this;
		
		this._swapChangeSetUriForParentInReferrerIfRequired()
			.then(dojo.hitch(this, function() {
				this.session.doSaveAsync(
					function(response, ioArgs) {
						self.updateSession(self.session, self.finalStep);
						self._retainSession = true;
						// remove this session from the local storage cache, otherwise
						// when we redirect back to the RM UI, it'll discover the incorrect
						// state for the change set.
						self._processRedirect();
					},
					
					function(response, ioArgs) {
						/*
						 * If this is compare only mode, and session has timed out, 
						 * then redirect back to the referer because there is no cancel button.
						 * 
						 * If the error is something else, ignore it. The session will
						 * expire automatically after some time anyway.
						 */
						self.session.setState(previousState);
						self.showErrorMessage(response, ioArgs);
						self.hideLoadingMessage();
						
					});
		}));
	},
	
	_ensurePromise: function(objectOrPromise) {
		// summary:
		//		Helper to handle cases where we need to guarantee that a given value is a promise.
		//		Useful for situations where an interface gives us a value or a promised value, depending on
		//		whether the value is immediately available, but we want to make use of an interface that needs
		//		a promise.  dojo.when can sometimes be used in such situations, but is not always ideal.  If dojo.when is given a promise, it returns a promise.  If it is given a
		//		non-promise, it returns that non-promise, so that value cannot be returned directly to
		//		a caller that is expecting a promise (the caller would also have to know to use
		//		dojo.when()) or passed to an interface that is expecting a promise.
		//
		//	TODO: It may be better to create a full wrapper replacement for dojo.when, so that if an
		//		error occurs in the called function a promise that is in error can be returned.
		if (objectOrPromise && dojo.isFunction(objectOrPromise.then)) {
			// Got a promise or deferred
			if (dojo.isFunction(objectOrPromise.addCallback)) {
				// Got a deferred.  Return a promise, since a deferred doesn't have all
				// the methods that a promise has.
				return objectOrPromise.promise; 
			}
			return objectOrPromise;
		}
		// need to create a promise that is pre-resolved with the objectOrPromiseValue.
		var deferred = new dojo.Deferred();
		deferred.callback(objectOrPromise);
		return deferred.promise;
	}
	
});
dojo.declare("com.ibm.team.repository.web.ui.internal.wizard.LogoFooter", [dijit._Widget, dijit._Templated], {
	
	templatePath: dojo.moduleUrl("com.ibm.team.repository.web", "ui/internal/wizard/templates/LogoFooter.html"),
	
	constructor: function() {
		this.messages = dojo.i18n.getLocalization("com.ibm.team.repository.web.ui.internal.wizard", "WizardApplicationMessages");
	}

});
dojo.declare("com.ibm.xtools.rmps.web.deliver.server.core.ui.internal.deliver.DeliverExternalWizardStep", [ExternalWizardStep], {

	compareOnly: false,
	wizardApp: null,

	canFinish: function() {
		return this.compareOnly;
	},
	
	onFinish: function() {
		if (this.compareOnly && this.wizardApp) {
			this.wizardApp.performFinish();
		} else {
			this.inherited(arguments);
		}
	}
});

})();