/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corporation 2013, 2014, 2015 All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function InfoContentUtils() {
dojo.provide("com.ibm.xtools.rmps.web.deliver.shared.web.ui.util.InfoContentUtils");

dojo.require("dijit.layout.BorderContainer");

dojo.require("com.ibm.xtools.rmps.web.deliver.shared.web.ui.util.InfoContent");
dojo.require("com.ibm.xtools.rmps.web.deliver.shared.web.ui.util.SimpleDialogContent");
dojo.require("com.ibm.xtools.rmps.web.deliver.shared.web.ui.util.QuestionDialogContent");
dojo.require("com.ibm.xtools.rmps.web.deliver.shared.web.ui.util.PromptDialogContent");
dojo.require("com.ibm.xtools.rmps.web.deliver.shared.web.ui.util.ThreeButtonQuestionDialogContent");

dojo.requireLocalization("com.ibm.xtools.rmps.web.deliver.shared.web.ui.util", "InfoContentMessages");
var Messages = dojo.i18n.getLocalization("com.ibm.xtools.rmps.web.deliver.shared.web.ui.util", "InfoContentMessages");

dojo.require("jazz.ui.Dialog");

	com.ibm.xtools.rmps.web.deliver.shared.web.ui.util.InfoContentUtils = {
	    
	    showSimpleContentDialog: function __showSimpleContentDialog(title, messageContent){
	    	var extraParams = {
	    		message: messageContent
	    	};
	    	this.showDialog(com.ibm.xtools.rmps.web.deliver.shared.web.ui.util.SimpleDialogContent, title, extraParams);
	    },
	    
	    showQuestionDialog: function __showQuestionDialog(title, messageContent, okContent, cancelContent, okFunction, cancelFunction) {
	    	var extraParams = {
	    		message: messageContent,
	    		okMessage: okContent,
	    		cancelMessage: cancelContent,
	    		okFunction: okFunction,
	    		cancelFunction: cancelFunction
	    	};
	    	this.showDialog(com.ibm.xtools.rmps.web.deliver.shared.web.ui.util.QuestionDialogContent, title, extraParams);
	    },
	    
	    showSimplePromptDialog: function __showSimplePromptDialog(title, messageContent, okContent, okFunction, cancelContent, defaultValue, onInputChange, maxLength){
	    	var extraParams = {
    			message: messageContent,
	    		okMessage: okContent,
	    		okFunction: okFunction,
	    		cancelMessage: cancelContent,
	    		defaultValue: defaultValue,
	    		onInputChange: onInputChange,
	    		maxLength: maxLength
	    	}
	    	this.showDialog(com.ibm.xtools.rmps.web.deliver.shared.web.ui.util.PromptDialogContent, title, extraParams);
	    },
	    
	    showThreeButtonQuestionDialog: function __showThreeButtonQuestionDialog(title, messageContent, firstButtonContent, secondButtonContent, cancelContent, firstButtonFunction, secondButtonFunction, cancelFunction) {
	    	var extraParams = {
	    		message: messageContent,
	    		okMessage: firstButtonContent,
	    		secondButtonMessage: secondButtonContent,
	    		cancelMessage: cancelContent,
	    		okFunction: firstButtonFunction,
	    		secondButtonFunction: secondButtonFunction,
	    		cancelFunction: cancelFunction
	    	};
	    	this.showDialog(com.ibm.xtools.rmps.web.deliver.shared.web.ui.util.ThreeButtonQuestionDialogContent, title, extraParams);
	    },
	    
	    showWaitingDialog: function __showWaitingDialog(title, message) {
			var root =  new dijit.layout.BorderContainer({
				region: "center",
				style: "margin-left: 16px; height:100%;"
			});
			this.root = root;
			
			var dialogMessageNode = dojo.create("div", {
				innerHTML: "<br /><p>" + (message ? message : Messages.waitingDialogDescription) + "</p><br />" 
			});
			root.domNode.appendChild(dialogMessageNode);

			return new jazz.ui.Dialog({
				primaryTitle: title ? title : Messages.waitingDialogTitle,
	            destroyContents: true,
				contentNode: root.domNode,
				closable: false
			});
	    },
	    
	    showDialog: function __showDialog(clazz, title, extraParams, closeHook){
	        var floatingPane;
	        var onOk = dojo.hitch(this, function(){
	            floatingPane.close();
	            floatingPane.destroy();
	        });
	        
	        var onClose = dojo.hitch(this, function(){
	            floatingPane.content.destroy();
	            delete floatingPane.content;
	        });

	        var params = this._getFloatingPaneParams(clazz, title, onOk, onClose, extraParams);
	        if (closeHook) {
	        	params.onClose = closeHook;
	        }
	        floatingPane= new jazz.ui.Dialog(params);

	        var content = params.content;
	        if (content && content.setFocus){
	            content.setFocus();
	        }
	    },

	    //extraParams is optional
	    _getFloatingPaneParams: function __getFloatingPaneParams(clazz, title, contentCloseCallback, dialogCloseCallback, extraParams){
	        var contentParams = {
	            onOk: dojo.hitch(this, contentCloseCallback),
	            onCancel: dojo.hitch(this, contentCloseCallback)
	        };
	        
	        if (extraParams) {
		        for (var param in extraParams) {
		        	contentParams[param] = extraParams[param];
		        }
	        }
	        
	        var content = new clazz(contentParams);

	        var floatingPaneParams = {
	            contentNode: content.domNode,
	            content: content,
	            onClose: dialogCloseCallback
	        };
	        floatingPaneParams.primaryTitle = title;
	        return floatingPaneParams;
	    }
	
	};

}());