/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2011, 2015.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("rmps.app.ui.internal.application.AdminMenu");

dojo.require("com.ibm.team.repository.web.ui.internal.admin.AdminMenu");

dojo.require("com.ibm.team.repository.web.configurationManagement.cache.CmCacheFactory");
var CmCacheFactory = com.ibm.team.repository.web.configurationManagement.cache.CmCacheFactory;

dojo.require("com.ibm.team.repository.web.configurationManagement.CmConstants");
var CmConstants = com.ibm.team.repository.web.configurationManagement.CmConstants;

dojo.require("dojo.i18n");
dojo.requireLocalization("rmps.app.ui.internal.application", "ApplicationMessages");

var messages = dojo.i18n.getLocalization("rmps.app.ui.internal.application", "ApplicationMessages");

dojo.declare("rmps.app.ui.internal.application.AdminMenu", com.ibm.team.repository.web.ui.internal.admin.AdminMenu, {
	
	_populateMenu: function() {
		if (!this.domNode) {
			return;
		}

		if (this._loading) {
			// remove the message that indicates that the message is loading
			this.remove(this._loading);
			this._loading.destroy();
			this._loading = null;
		}

		// Add the Manage configuration menu
		var currentConfigUri = jazz.app.context.get().baseline;
		var componentForProject = null;
		if (currentConfigUri) {
			CmCacheFactory.getConfigurationCache().get(currentConfigUri).then(dojo.hitch(this, function(configObject) {
				componentForProject = configObject.componentUri;
				this.addItemByArgs({
					label: messages.manageConfigurations,
					href: "#action=" + CmConstants.CONFIGURATION_EXPLORER_ACTION + "&componentUri=" + encodeURIComponent(componentForProject)
				}, 0);
			}));			
		}
		
		// Add the Project Properties menu item if applicable.
		if (this.showProjectProperties) {
			this.addItemByArgs({
				label: messages.projectProperties,
				href: "#action=jazz.viewPage&id=rmps.app.settings"
			});
			this.addSeparator();
		}
		
		// Call inherited
		this.inherited(arguments);
		
		// Remove the reports link
		// See https://jazz.net/jazz04/resource/itemName/com.ibm.team.workitem.WorkItem/27976
		var items = this.getItems();
		var reportsItem = null;
		if (items && items.length) {
			for (var i = 0; i < items.length; i++) {
				var item = items[i];
				if (item.href && item.href.indexOf("com.ibm.team.reports.reportsManagementPage") !== -1) {
					reportsItem = item;
					break;
				}
			}
		}
		if (reportsItem) {
			this.remove(reportsItem);			
		}
	}
});

}());