/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2009, 2015.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
if (dojo.isIE >= 8) {
	// Workaround for IE8 standards mode
	try{
		document.namespaces.add("v","urn:schemas-microsoft-com:vml");
		var vmlElems = ["*", "group", "roundrect", "oval", "shape", "rect", "imagedata"],
			i = 0, l = 1, s = document.createStyleSheet();
		if(dojo.isIE >= 8){
			i = 1;
			l = vmlElems.length;
		}
		for(; i < l; ++i){
			s.addRule("v\\:" + vmlElems[i], "behavior:url(#default#VML); display:inline-block");
		}
	}catch(e){}
}

/* The following meta tag will remove the url header when the
 * web application is running on an iPad - this is desirable
 * but it's problematic ( I think for oauth security )

	var meta = document.createElement('meta');
	meta.name = "apple-mobile-web-app-capable";
	meta.content = "yes"
	headID.appendChild(meta);
*/

/* The following link tag determines the icon used for the
 * home screen link on an ipad
 */

var headID = document.getElementsByTagName("head")[0];

var link = document.createElement('link');
link.rel = "apple-touch-icon";
link.href = dojo.moduleUrl( "rmps.app.ui","internal/application/images/dmbluebutton.png" );
headID.appendChild(link);

(function() {
dojo.provide("rmps.app.ui.internal.application.ModelingApplication");

dojo.require("rmps.app.core.internal.WebUiInitializers");

dojo.require("rmps.app.core.internal.Workarounds");

dojo.require("rmps.core.RootServices");
dojo.require("rmps.core.BackendScr");
dojo.require("rmps.core.util.IRmpsConstants");
dojo.require("com.ibm.team.app.web.RepositoryApplication");
dojo.require("jazz.app.auth");
dojo.require("jazz.app.proxy");
dojo.require("jazz.ui.Dialog");

dojo.require("dojo.i18n");

dojo.require("dojo.io.iframe");

dojo.require("dojo.DeferredList");

dojo.require("jazz.client.xhr");

dojo.require("jazz.core.loader");

dojo.require("rmps.ui.ErrorReportController");
dojo.require("rmps.core.error");
dojo.require("rmps.ui._Styles");

dojo.require("rmps.core.user.UserClient");
dojo.require("rmps.app.ui.internal.util.UrlUtil");

dojo.require("dojox.xml.DomParser");

dojo.require("rmps.app.ui.internal.application.AdminMenu");

dojo.require("com.ibm.team.repository.web.configurationManagement.CmTools");
var CmTools = com.ibm.team.repository.web.configurationManagement.CmTools;

dojo.require("com.ibm.team.repository.web.configurationManagement.CmEvents");
var CmEvents = com.ibm.team.repository.web.configurationManagement.CmEvents;

dojo.require("com.ibm.team.repository.web.configurationManagement.notifications.CmNotificationConstants");
var CmNotificationConstants = com.ibm.team.repository.web.configurationManagement.notifications.CmNotificationConstants;

dojo.require("com.ibm.team.repository.web.configurationManagement.cache.CmCacheFactory");
var CmCacheFactory = com.ibm.team.repository.web.configurationManagement.cache.CmCacheFactory;

dojo.require("com.ibm.team.repository.web.configurationManagement.contextBannerButton.ContextBannerButton");
var ContextBannerButton = com.ibm.team.repository.web.configurationManagement.contextBannerButton.ContextBannerButton;

dojo.require("rmps.core.util.ContextUtils");

dojo.require("rmps.app.ui.internal.dialogs.InvalidConfigurationContextDialog");
dojo.require("rmps.app.ui.internal.util.DomainRegistryUtil");

dojo.require("net.jazz.ajax.viewletServiceRoot");
dojo.require("rmps.app.ui.internal.util.DmProjectAreaConverter");

dojo.require("com.ibm.team.configuration.web.context.ContextAPI");
var ContextAPI = com.ibm.team.configuration.web.context.ContextAPI;

dojo.require("rmps.core.oslc_config.OslcConfigClient");
var OslcConfigClient = rmps.core.oslc_config.OslcConfigClient;
dojo.requireLocalization("rmps.app.ui.internal.application", "ApplicationMessages");

dojo.require("rmps.app.ui.internal.pages.MinibarCellSidebar");

var messages = dojo.i18n.getLocalization("rmps.app.ui.internal.application", "ApplicationMessages");
var jfsMessages = dojo.i18n.getLocalization("com.ibm.team.app.web.internal", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
var PlatformUI = net.jazz.ajax.ui.PlatformUI;

dojo.require("rmps.app.ui.internal.context.DmContextBannerButton");
var DmContextBannerButton = rmps.app.ui.internal.context.DmContextBannerButton;

var JTS_IDENTIFIER = "http://jazz.net/application/jts";

dojo.require("jazz.core.loader");

// 40963 - need to preload gfx so that Impact Analysis loads properly
dojo.require("dojox.gfx");
dojo.require("dojox.gfx.Moveable");
dojo.require("dojox.collections.ArrayList");
dojo.require("dojox.dtl.Context");
dojo.require("dojox.dtl.tag.logic");

dojo.require("net.jazz.ajax.isNotContainerAuthentication");

dojo.requireIf = function relmRequireIf(condition, module) {
	if (condition) {
		jazz.core.loader.load_async(module, function() {
			console.debug('Conditionally include module:' + module); //$NON-NLS-1$
		});
	}
};

/*
 * Update the prototype of JTS ProjectAreaEditor widget such that it has our extensions of it.
 * Other applications such as CCM, RM, QM all get their own copy of the widget
 * Safe to do this here, because AdminApplication is loaded before ProjectAreaEditor widget created 
 */
rmps.app.ui.internal.util.DmProjectAreaConverter.convert();

dojo.declare("rmps.app.ui.internal.application.ModelingApplication", com.ibm.team.app.web.RepositoryApplication, {

	name: messages.productName,
	iconSmall: dojo.moduleUrl("rmps.app", "graphics/DM_16.png"),
	iconLarge: dojo.moduleUrl("rmps.app", "graphics/DM_24.png"),

	_setup: false,

	autoRequestInitData: false,
	applicationContext: null,
	newHref: null,

	constructor: function(args) {
		// ensure the web URI is correct
		var webUri = rmps.core.RootServices.getUri(rmps.core.Namespaces.RMPS, "web");
		var uri = String(window.location);
		if (uri.search(new RegExp("^" + webUri, "i")) !== 0) {
			// redirect to web URI
			var pathPrefix = new dojo._Url(webUri).path;
			var idx = uri.search(new RegExp(pathPrefix, "i"));
			window.location = webUri + uri.substr(idx + pathPrefix.length);
		} else {
			if (this._isSetup()) {
				this.fetchInitData();
			}
		}
		
		this.gettingStartedLink = "http://www.ibm.com/support/knowledgecenter/SSB2MU_8.1.2/com.ibm.xtools.rcam_prodover.doc/topics/t_gs_dm.html";
	},

	_fetchUserRolesSuccess: function() {
		this.fetchInitData();
	},
	
	start: function() {
		this.config.user.uri = this.config.user.userId ? rmps.core.user.UserClient.getUserUri(this.config.user.userId) : "";

		// check if we should go to landing page
		var context = jazz.app.context.get();
		if (context && !context.name) {
			// Go to home link
			window.location.href = this.getHomeLink();
			return;
		}
		

		/*
		 * No context supplied need open project
		 * area list. Done in initContext() in the
		 * super. Override here, because navigation
		 * to that page happens in the start()
		 * function called at the end of the
		 * initContext()
		 */
		
		// Suppress the 'Settings' page since it's accessible from admin menu.
		var sp = dojo.getObject("com.ibm.team.repository.web.suppressedPages");
		if (sp) {
			var spIsString = dojo.isString(sp);
			if (spIsString) {
				sp = dojo.fromJson(sp);
			}
			var appId = PlatformUI._getApplicationId();
			var spa = sp[appId];
			if (!spa) {
				sp[appId] = spa = [];
			}
			if (dojo.indexOf(spa, "rmps.app.settings") === -1) {
				spa.push("rmps.app.settings");
			}
			dojo.setObject("com.ibm.team.repository.web.suppressedPages", spIsString ? dojo.toJson(sp) : sp);
		}
		
		this._initializeContextSelector();
		
		// if we are on a deleted/committed changeset context, 
		// display a dialog and redirect to parent when the dialog is closed
		if (this.newHref){
			var dialogContent = document.createElement("div");
			dialogContent.innerHTML = '<div>' + messages.redirectToParent + '</div><br>'+
			'<table align=right>' +
				'<tr>' +
					'<td><button dojoAttachPoint="_closeButton">' + messages.closeButton + '</button></td>' +
				'</tr>' +
			'</table>';
			
			dojo.connect(dialogContent._closeButton, "onclick",  dojo.hitch(this, this._navigateToParent));

			new jazz.ui.Dialog({
				primaryTitle: messages.redirectTitle,
				isClosable: true,
				contentNode: dialogContent,
				onClose: dojo.hitch(this, this._navigateToParent)
			});
		} else {
			this.inherited(arguments);

			// handle return from configuration creation
			var uri = window.location.href;
			var pattern = "&creatingConfiguration=";
			var i = uri.indexOf(pattern);
			if (i !== -1) {
				var configName = unescape(decodeURIComponent(uri.substring(i + pattern.length)));
				var msg = dojo.string.substitute(messages.creatingConfiguration, [ configName ]);
				var action = dojo.string.substitute(messages.creatingConfigurationAction, [ configName ]);
				rmps.core.error.createInfo(msg, action).dispatch();
			}
		}
	},

	_navigateToParent: function()
	{
		window.location.href = this.newHref;
	},

	_setContext: function(configurationUri, changeSetUri, globalConfigurationUri) {
		var context = {
			localConfigurationUri : configurationUri,
			changeSetUri : changeSetUri,
			globalConfigurationUri : globalConfigurationUri
		};
		CmTools.setContext(context);		
	},

	_getComponent: function() {
		var def = new dojo.Deferred();
		var projectId = jazz.app.context.get().itemId;
		OslcConfigClient.getComponentUrisFromProjectId(projectId).then(function(result) {
			// TODO: multiple components?
			if (result[0]) {
				def.callback(result[0]);
			} else {
				def.errback();
			}
		}, def.errback);
		return def;
	},
	
	_initializeContextSelector: function()
	{
		var currentContextUri = rmps.core.util.ContextUtils.getCurrentContextURI();
		var expandedContextUri = rmps.core.util.ContextUtils.getExpandedContext();
		if (expandedContextUri) {
			this._getComponent().then(dojo.hitch(this, function(component) {
				rmps.core.util.ContextUtils.getLCfromGCandComponent(expandedContextUri, component, dojo.hitch(this, function() {
					// Unhappy path. No LC found matching GC. Redirect to the LC if it exists. Otherwise let server decide
					if (currentContextUri) {
						rmps.core.util.ContextUtils.setContext(currentContextUri, null, null);
					} else {
						rmps.core.util.ContextUtils.setContext(null, null, null);
					}
				})).then(function(configs) {
					// Verify LC matching GC
					var localConfigurationUri = decodeURIComponent(configs[0]);
					if (currentContextUri !== localConfigurationUri) {
						// Unhappy Path. Wrong LC with the GC. Redirect
						rmps.core.util.ContextUtils.setContext(localConfigurationUri, null, expandedContextUri);
					}
				});
			}));
		}
		if (currentContextUri && currentContextUri.indexOf("/cm/changeset/") !== -1) {
			CmCacheFactory.getChangeSetsCache().get(currentContextUri).then(dojo.hitch(this, function(data){
				this._setContext(data.parentStreamUri, currentContextUri, expandedContextUri);
			}));
		} else {
			this._setContext(currentContextUri, null, expandedContextUri);
		}		
	},
	
	onContextChange: function(context) {
		// Change sets is using configurations URIs (set with CmTools.cmConfig.workWithChangeSetConfigurations)
		var localConfigurationUri = context.localConfigurationUri || context.changeSetUri;
		var globalConfigurationUri = context.globalConfigurationUri;
		
		if (!localConfigurationUri && globalConfigurationUri) {
			// GC, get the LC
			// Secondly, ask the GC app for the LC based on GC + component
			//var componentUri = net.jazz.ajax.BootstrapProperties.FRONTSIDE_URL + '/cm/component/' + jazz.app.context.get().itemId;
			this._getComponent().then(function(component) {
				rmps.core.util.ContextUtils.getLCfromGCandComponent(context.globalConfigurationUri, component).then(function(configs) {
					localConfigurationUri = decodeURIComponent(configs[0]);
					if (localConfigurationUri) {			
						// Save as recently used
						ContextAPI.saveAsCurrentContext({
							uri: globalConfigurationUri || localConfigurationUri,
							isGlobal: !!globalConfigurationUri,
							rdfType: context.changeSetUri ? "changeset" : null
						}).then(function() { 
							if (globalConfigurationUri) {
								rmps.core.util.ContextUtils.setContext(localConfigurationUri, null, globalConfigurationUri);
							} else {
								rmps.core.util.ContextUtils.setContext(localConfigurationUri, null);
							}
						});			
					}
				});
			});
		}
		
		if (localConfigurationUri) {			
			// Save as recently used
			ContextAPI.saveAsCurrentContext({
				uri: globalConfigurationUri || localConfigurationUri,
				isGlobal: !!globalConfigurationUri,
				rdfType: context.changeSetUri ? "changeset" : null
			}).then(function() { 
				if (globalConfigurationUri) {
					rmps.core.util.ContextUtils.setContext(localConfigurationUri, null, globalConfigurationUri);
				} else {
					rmps.core.util.ContextUtils.setContext(localConfigurationUri, null);
				}
			});			
		}
	},
		
	getRedirect: function() {
		var projectId = jazz.app.context.get().itemId;
		var link = rmps.core.RootServices.getUri(rmps.core.Namespaces.RMPS, "queryvvc");

		return link + "/redirectfromcreation?projectId=" + projectId;
	},	

	getHomeLink: function() {
		return rmps.core.RootServices.getUri(rmps.core.Namespaces.JDB, "dashboards"); //$NON-NLS-1$
	},

	_createExplorerDrawer: function() {
		var table = dojo.query("table.content-table")[0];
		if (!table) {
			return;
		}

		// Add a cell in the table for the explorer
		var td = table.rows[0].insertCell(1);
		dojo.style(td, "vertical-align", "top");
		
		// Make footer cell expand over the new cell as well
		table.rows[1].cells[1].colSpan = 2;

		var sidebarInstance = new rmps.app.ui.internal.pages.MinibarCellSidebar({
			pageTemplate: this.ui
		});
		td.appendChild(sidebarInstance.domNode);
		sidebarInstance.startup();
	},
	
	initContext: function() {
		var errorReport = new rmps.ui.ErrorReportController();
		errorReport.startup();
		this.inherited(arguments);
		if (this.ui.containerNode.firstChild) {
			this.ui.containerNode.insertBefore(errorReport.domNode, this.ui.containerNode.firstChild);
		} else {
			this.ui.containerNode.appendChild(errorReport.domNode);
		}

		this._createExplorerDrawer();

		var context = this.getCurrentContext();
		if (context && context.itemId) {
			// Only add the VVC banner button if we're in a project context.
			var bannerButtons = this.ui.get("bannerRight");	
			
			if (bannerButtons)
			{
				//var args = {};
				//args.workspaceBasedOffSnapshotOnly = false;
				//args.redirectUriSelector = this.getRedirect;
				//args.app = this;
				//this.contextBannerButton = new rmps.app.ui.internal.application._ConfigurationContextBannerButton(args);
				//this.contextBannerButton.onContextChange = this.onContextChange;
				
				this.contextBannerButton = new DmContextBannerButton();
				var pipeNode = document.createElement("span");
				dojo.addClass(pipeNode, 'pipe');
				pipeNode.innerHTML = "|";
				dojo.place(pipeNode, bannerButtons.domNode, "first");
				dojo.place(this.contextBannerButton.domNode, bannerButtons.domNode, "first");
								
				// Add listener to configuration changes
				dojo.subscribe(CmEvents.USER_REQUESTED_CONTEXT_CHANGE, this, this.onContextChange);
				// Add listener to error channel
				dojo.subscribe(CmNotificationConstants.ERROR_CHANNEL, this, this._onCMError);
			}
		}
	},
	
	_onCMError: function(args) {
		if (args) {
			rmps.core.error.createCMError(args).dispatch();			
		}
	},
	
	getCurrentContext: function() {
		if (this.applicationContext) {
			/*Required to track the baseline changes while working */
			this.applicationContext.baseline = this._getBaselineFromUrl();

			return this.applicationContext;
		}
		this.applicationContext = this.inherited(arguments);
		/*Required to track the baseline changes while working */
		this.applicationContext.baseline = this._getBaselineFromUrl();
		if (this.applicationContext.name) {
			var self = this;
			var args = {
				url: rmps.core.RootServices.getUri(rmps.core.Namespaces.JP_0_6, "projectAreas"),
				 /*
				 * Handle as XML (not parasable text) due to that dojo bug:
				 *
				 * http://bugs.dojotoolkit.org/ticket/14290
				 *
				 * But make sure to deal with the behaviour differences in XML manipulation
				 *
				 */
				handleAs: "xml",
				load: function(doc, ioArgs) {

					/*
					 * Required for WebKit browsers (Safari, Chrome, etc). We do not use the prefix when getting the elements by tag name (when using the
					 * method getElementsByTagName). Thus, in order to maintain the same behavior on all browsers versions, we use our method, till 14290
					 * is resolved
					 *
					 */
					var getNode = function(parentNode, tagName) {
						var list = [];
						var childNodes = parentNode.childNodes;

						/*no need to check for childNodes being defined */
						var length = childNodes.length;

						for(var index = 0; index < length; index++) {
							var current = childNodes[index];
							if (current.tagName === tagName) {
								list.push(current);
							}
						}
						return list;
					};

					var projectsMainNode = getNode(doc, "jp06:project-areas")[0];

					var projects = getNode(projectsMainNode, "jp06:project-area");

					var pas = [];
					for (var i = 0, p; p = projects[i]; ++i) {
						var c = {};
						pas.push(c);
						c.name = p.getAttribute("jp06:name");

						c.archived = getNode(p, "jp06:archived")[0].childNodes[0].nodeValue === true;
						c.uri = getNode(p, "jp06:url")[0].childNodes[0].nodeValue;
						var segments = c.uri.split('/');
						c.itemId = segments[segments.length - 1];
						if (c.name === self.applicationContext.name) {
							self.context = c.uri;
						}
					}
					self.config.projectAreas = pas;

				}
			};
			jazz.client.xhrGet(args);
		}

		return this.applicationContext;
	},

	_isSetup: function() {
		if (net.jazz.ajax.viewletServiceRoot()) {
			return true;
		}
		this.ui._homeMenu.style.display = this.ui._searchArea.style.display = "none";
		this.config.showLoginLogout = false;
		this.onFailure(null, messages.setupError);
		return false;
	},

	_getBaselineFromUrl: function() {
		var curUrl = new dojo._Url(location.href);
		var query = curUrl.query;
		if (query) {
			var queryParameters = dojo.queryToObject(query.substring(query.indexOf("?") + 1, query.length));
			var contextUri = queryParameters[rmps.core.util.IRmpsConstants.BASELINE];
			if (contextUri instanceof Array) {
				contextUri = contextUri[0];
			}

			//for backwards compatibility with 3.0, convert internal baseline URL to front side URL
			if (contextUri) {
				var jtsBaselineUrl = rmps.core.RootServices.getUri(rmps.core.Namespaces.JFS_1_0, "baselines");
				if (contextUri.indexOf(jtsBaselineUrl !== -1)) {
					contextUri = contextUri.replace(jtsBaselineUrl, rmps.core.RootServices.getUri(rmps.core.Namespaces.RMPS, "dm-baselines"));
				}
			}
			return contextUri;
		} else {
			return null;
		}
	},

	_adminMenuProvider: function() {
		return new rmps.app.ui.internal.application.AdminMenu({showProjectProperties: this.context !== null});
	}
});

}());