/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2015. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  Use,
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/

(function DmMenuProvider() {
dojo.provide("rmps.app.ui.internal.context.DmMenuProvider");

dojo.require("com.ibm.team.repository.web.configurationManagement.contextBannerButton.menuProvider.MenuProvider");
dojo.require("com.ibm.team.repository.web.configurationManagement.contextBannerButton.menuProvider.CmMenuEntries");
dojo.require("com.ibm.team.repository.web.configurationManagement.contextBannerButton.menuProvider.CmMenuProvider");
dojo.require("com.ibm.team.repository.web.configurationManagement.CmButtonFactory");

var CmMenuEntries = com.ibm.team.repository.web.configurationManagement.contextBannerButton.menuProvider.CmMenuEntries;
var CmMenuProvider = com.ibm.team.repository.web.configurationManagement.contextBannerButton.menuProvider.CmMenuProvider;

dojo.require("rmps.app.ui.internal.context.DmMenuEntries");
var DmMenuEntries = rmps.app.ui.internal.context.DmMenuEntries;

dojo.requireLocalization("com.ibm.team.repository.web.configurationManagement.contextBannerButton.menuProvider", "CmMenuEntryMessages");
var CmMenuEntryMessages = dojo.i18n.getLocalization("com.ibm.team.repository.web.configurationManagement.contextBannerButton.menuProvider", "CmMenuEntryMessages"); 

dojo.declare("rmps.app.ui.internal.context.DmMenuProvider", CmMenuProvider, {
	
	getCreateConfigsSection: function __getCreateConfigsSection(builders){	
		var entries = [];
		entries.push(CmMenuEntries.getCreateStreamEntry(null, {
			makeFlush: true
		}));
		entries.push(CmMenuEntries.getCreateBaselineEntry(null, {
			makeFlush: true
		}));
		
		//add the edit dependencies entry
		entries.push(DmMenuEntries.getEditDependenciesEntry(null, {
			makeFlush: true
		}));
		
		entries.push(CmMenuEntries.getAcceptMenuEntry(null, {
			makeFlush: true
		}));
		entries.push(CmMenuEntries.getDeliverMenuEntry(null, {
			makeFlush: true
		}));
				
		var section = {
			title: CmMenuEntryMessages.createSection,
			entries: entries,
			newColumn: true
		};
		builders.push(section);	
	}
});

}());
