/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2015. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() { 
dojo.provide("rmps.app.ui.internal.linkvalidity.LinkValidityCommentWidget");

dojo.require("rmps.app.ui.internal.common.MessageForm");
dojo.require("rmps.app.ui.internal.linkvalidity.LinkValidityUtils");
dojo.require("rmps.app.ui.internal.linkvalidity.LinkValidityStatusComboButton");
dojo.require("dojo.i18n");

dojo.requireLocalization("rmps.app.ui.internal.linkvalidity", "LinkValidityControlWidget");

var LinkValidityUtils = rmps.app.ui.internal.linkvalidity.LinkValidityUtils,
	LinkValidityStatusComboButton = rmps.app.ui.internal.linkvalidity.LinkValidityStatusComboButton;

dojo.declare("rmps.app.ui.internal.linkvalidity.LinkValidityCommentWidget", [rmps.app.ui.internal.common.MessageForm], {
	
	status: LinkValidityUtils.LINK_STATUS.VALID,
	dialogWidth: "350px",
	dialogStyle: "ok",
	
	_input: null,
	_statusWidget: null,
	
	postMixInProperties: function() {
		this.inherited("postMixInProperties", arguments);
		
		// We have the messages, we can create the content.
		this.messages = dojo.i18n.getLocalization("rmps.app.ui.internal.linkvalidity", "LinkValidityControlWidget");
		this.dialogTitle = this.messages.setWithComment;
		var dialogNode = dojo.create("div");
				
		this._statusWidget = new LinkValidityStatusComboButton({status: this.status});
		dojo.place(this._statusWidget.domNode, dialogNode);
		this._input = dojo.create("textarea", {rows: 4, placeholder: this.messages.enterCommentPlaceholder, style: "width: 100%; max-width: 100%; margin-top: 5px;"}, dialogNode);
		this.confirmContent = dialogNode;
	},
	
	show: function() {
		this.inherited("show", arguments);
		this._input.focus();
	},
	
	getStatus: function() {
		return this._statusWidget.getStatus();
	},
	
	getValue: function() {
		return this._input.value;
	}
	
});
})();
