/******************************************************************************* 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2015. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() { 
dojo.provide("rmps.app.ui.internal.linkvalidity.LinkValidityControlWidget");

dojo.require("dojo.i18n");

dojo.require("rmps.app.ui.internal.linkvalidity.LinkValidityUtils");
dojo.require("rmps.app.ui.internal.linkvalidity.LinkValidityProfile");
dojo.require("jazz.ui.menu.MenuItem");
dojo.require("jazz.ui.Menu");
dojo.require("jazz.ui.toolbar.MenuButton");
dojo.require("jazz.ui.HoverPopup");
//dojo.require("rmps.app.ui.internal.linkvalidity.LinkValidityCommentWidget");
dojo.require("dijit.MenuSeparator");
dojo.require("dijit.PopupMenuItem");

dojo.requireLocalization("rmps.app.ui.internal.linkvalidity", "LinkValidityControlWidget");

var LinkValidityUtils = rmps.app.ui.internal.linkvalidity.LinkValidityUtils,
    LinkValidityProfile = rmps.app.ui.internal.linkvalidity.LinkValidityProfile,
	MenuItem = jazz.ui.menu.MenuItem,
	Menu = jazz.ui.Menu,
	MenuButton = jazz.ui.toolbar.MenuButton,
	HoverPopup = jazz.ui.HoverPopup,
	DateTimeHelper = rmps.app.ui.internal.common.DateTimeHelper,
//	LinkValidityCommentWidget = rmps.app.ui.internal.linkvalidity.LinkValidityCommentWidget,
	MenuSeparator = dijit.MenuSeparator,
	PopupMenuItem = dijit.PopupMenuItem;
	

dojo.declare("rmps.app.ui.internal.linkvalidity.LinkValidityControlWidget", [jazz.ui.toolbar.MenuButton], {
	
	projectUri: null,
	entry: null,		// The validity status entry that this widget represents
	injectCaret: false,	// suppress the caret in the button menu
	enabled: false,		// Default to false. The menu will only be enabled if the permissions are ok.

	_projectPermissionsDfd: null,
	_messages: null,
	_menu: null,
	_listeners: null,
	_hover: null,
	
	menuProvider: function() {
		return this._menu;
	},
    
    open: function(){
        if (this._hover){
            this._hover.enabled = false;
            this._hover.close();
        }
        this.inherited("open", arguments); 
    },
    
    close: function(){
        if (this._hover){
            this._hover.enabled = true;
        }
       this.inherited("close", arguments); 
    },
	
	postMixInProperties: function() {
		this._messages = dojo.i18n.getLocalization("rmps.app.ui.internal.linkvalidity", "LinkValidityControlWidget");
	},
	
	postCreate: function() {
		this.inherited("postCreate", arguments);
		
		this._listeners = [];
		this.set("enabled", true);
//		this._projectPermissionsDfd =
//			ProjectCache.getProjectPermissions(
//				this.projectUri);
//		
//		// Check permissions
//		this._projectPermissionsDfd.then(dojo.hitch(this, function(permissions) {
//			if(permissions.item(rmps.app.ui.internal.common.ProjectCache.ASSERT_LINK_VALIDITY)) {
//				this.set("enabled", true);
//			}else{
//				// Added for the Defect 98803 REL 6.0.1-S3 -- Wrongly the showing the hand symbol when Hovered on a link even though user don't have the permission.
//				dojo.addClass(this.domNode, "nopermission");
//			}
//			
//		}));
    	
		// Create the menu
		this._menu = new Menu({
			selectable: true
		});
		this._menu.addChild(new MenuItem({
	        label: this._messages.valid,
	        iconClass: "com-ibm-rdm-web-linkvalidity-valid-icon",
	        onClick: dojo.hitch(this, function(evt) {
	        	this._setStatus(LinkValidityUtils.LINK_STATUS.VALID);
	        })
	    }));
		this._menu.addChild(new MenuItem({
	    	label: this._messages.invalid,
	        iconClass: "com-ibm-rdm-web-linkvalidity-invalid-icon",
	        onClick: dojo.hitch(this, function(evt) {
	        	this._setStatus(LinkValidityUtils.LINK_STATUS.INVALID);
	        })
	    }));
		this._menu.addChild(new MenuItem({
	    	label: this._messages.unknown,
	        iconClass: "com-ibm-rdm-web-linkvalidity-unknown-icon",
	        onClick: dojo.hitch(this, function(evt) {
	        	this._setStatus(LinkValidityUtils.LINK_STATUS.UNKNOWN);
	        })
	    }));

    	// Create the submenu to set validity with comments
//    	this._menu.addChild(new MenuSeparator());
//    	var subMenu = new Menu();
//    	subMenu.addChild(new MenuItem({
//	        label: this._messages.valid,
//	        iconClass: "com-ibm-rdm-web-linkvalidity-valid-icon",
//	        onClick: dojo.hitch(this, function(evt) {
//	        	this._showCommentDialog(LinkValidityUtils.LINK_STATUS.VALID);
//	        })
//	    }));
//    	subMenu.addChild(new MenuItem({
//	    	label: this._messages.invalid,
//	        iconClass: "com-ibm-rdm-web-linkvalidity-invalid-icon",
//	        onClick: dojo.hitch(this, function(evt) {
//	        	this._showCommentDialog(LinkValidityUtils.LINK_STATUS.INVALID);
//	        })
//	    }));
//    	subMenu.addChild(new MenuItem({
//	    	label: this._messages.unknown,
//	        iconClass: "com-ibm-rdm-web-linkvalidity-unknown-icon",
//	        onClick: dojo.hitch(this, function(evt) {
//	        	this._showCommentDialog(LinkValidityUtils.LINK_STATUS.UNKNOWN);
//	        })
//	    }));
//    	this._menu.addChild(new PopupMenuItem({
//            label: this._messages.setWithComment,
//            iconClass: "com-ibm-rdm-web-linkvalidity-blank-icon", // Give an empty iconClass for alignment purposes
//            popup: subMenu
//        }));
    	
    	// Set the initial state of the menu
    	this.updateMenu();
		
//		this._listeners.push(ChangeNotifier.addListener({
//			eventTopic: EventTopics.LINK_VALIDITY_UPDATED,
//			callbackFunction: dojo.hitch(this, this.updateEntry),
//			callbackScope: this,
//			projectURI: this.projectURI
//		}));
//		
//		
//		this._listeners.push(ChangeNotifier.addListener({
//			eventTopic: EventTopics.LINKS_EXPLORER_VALIDITY_STATUS_UPDATED,
//			callbackFunction: dojo.hitch(this, this.updateValidityStatusEntry),
//			callbackScope: this,
//			projectURI: this.projectURI
//		}));
	},
	
	uninitialize: function() {
		if (this._hover) {
			this._hover.destroy();
		}
		dojo.forEach(this._listeners, dojo.hitch(this, function(listener) {
			ChangeNotifier.removeListener(listener);
		}));
	},
	
	updateMenu: function() {
		var imgClass;
		if (this.entry.status === LinkValidityUtils.LINK_STATUS.IGNORED) {
			// Link validity cannot be set on this artifact
			dojo.style(this.domNode, "visibility", "hidden");
			return;
		}
		dojo.style(this.domNode, "visibility", "");
		this._setValidityIcon();
		
		// Init the hover. Will happen from appropriate events and startup.
		this._initializeHover();
	},
	
	updateEntry: function(args) {
		var entries = args.notifierParams.entries;
		if (!entries || !entries.length) {
			return;
		}
		for (var i = 0; i < entries.length; i++) {
			// See this widget represents the updated entry. If so, update the menu.
			var entry = entries[i];
			if (this.entry.linkType === entry.linkType
					&& this.entry.sourceConceptId === entry.sourceConceptId
					&& this.entry.targetConceptId === entry.targetConceptId) {
				dojo.mixin(this.entry, entry);
				this.updateMenu();
				break;
			}
		}
	},
	
	updateValidityStatusEntry: function(args){
		var entries = args.notifierParams.entries;
		if (!entries || !entries.length) {
			return;
		}
		for (var i = 0; i < entries.length; i++) {
			// See this widget represents the updated validity status entry. If so, update the menu.
			var entry = entries[i];
			if(this.entry.linkUri && (this.entry.linkUri === entry.linkUri)){
				dojo.mixin(this.entry, entry);
				this.updateMenu();
				break;
			}
		}
	},
	
	_showCommentDialog: function(status) {
		// First, determine if we are under edit. If we are, do not allow user to set validity.
//		LinkValidityUtils.checkUnderEdit(dojo.hitch(this, function() {
//			var dialog = new LinkValidityCommentWidget({
//				status: status,
//				onOk: dojo.hitch(this, function() {
//					this._setStatus(dialog.getStatus(), dialog.getValue());
//				})
//			});
//			dialog.show();
//		}));
	},
	
	_setStatus: function(status, comment) {
		
		// First, determine if we are under edit. If we are, do not allow user to set validity.
		var postData = [{
			linkType: this.entry.linkType,
			linkUri: this.entry.linkUri,
			sourceConceptId: this.entry.sourceConceptId,
			targetConceptId: this.entry.targetConceptId,
			status: status,
			validityDescription: comment ? comment : ""
		}];
		LinkValidityUtils.updateValidity(postData);
		this.entry.status = status;
		this._statusChanged();
	}, 
	
	_statusChanged: function() {
		this._setValidityIcon();
		this._initializeHover();
	},
	
	_setValidityIcon: function() {
		switch (this.entry.status) {
		case LinkValidityUtils.LINK_STATUS.VALID:
            if (LinkValidityProfile.getDownstreamLinkTypes()[this.entry.linkType]) {
			    imgClass = "com-ibm-rdm-web-linkvalidity-valid-hollow-icon";
            } else {
                imgClass = "com-ibm-rdm-web-linkvalidity-valid-icon";
            }
			break;
		case LinkValidityUtils.LINK_STATUS.INVALID:
            if (LinkValidityProfile.getDownstreamLinkTypes()[this.entry.linkType]) {
			    imgClass = "com-ibm-rdm-web-linkvalidity-invalid-hollow-icon";
            } else {
                imgClass = "com-ibm-rdm-web-linkvalidity-invalid-icon";
            }
			break;
		case LinkValidityUtils.LINK_STATUS.UNKNOWN:
            if (LinkValidityProfile.getDownstreamLinkTypes()[this.entry.linkType]) {
			    imgClass = "com-ibm-rdm-web-linkvalidity-unknown-hollow-icon";
            } else {
                imgClass = "com-ibm-rdm-web-linkvalidity-unknown-icon";
            }
			break;
		default:
			// No status.
			return;
	    }
	    this.set({imgClass: imgClass});
	},
	
	_initializeHover: function() {
		if (this._hover) {
			this._hover.destroy();
		}
		this._hover = new HoverPopup({
			around: this.domNode,
			createContents: this._createPopupContent.bind(this),
			destroyContents: true,
			openDelay: 1000
		});
	},
	
	_createPopupContent: function() {
		// Creates the content of the popup hover based on the rollup status entry
		//	and a generated map of the links for the resource this rollup represents
		var container = dojo.create("div", {"class": "com-ibm-rdm-web-linkvalidity-hover"});
		var closeButton = dojo.create("div", {"class": "close-button"}, container);
		this.connect(closeButton, "onclick", dojo.hitch(this, function(evt) {
			this._hover.close();
		}));
		var detailsDiv = dojo.create("div", null, container);
		
		// Place an initial loading message in the popup
		var loadingDiv = dojo.create("div", null, detailsDiv);
		loadingDiv.appendChild(document.createTextNode(this._messages.loading));
		
//		this._getFullValidityDetails().then(dojo.hitch(this, function(fullDetails){

			dojo.style(loadingDiv, "display", "none");
			
			if (this.entry){
				var entry = this.entry;
				
				var status = null;
				switch (entry.status) {
					case LinkValidityUtils.LINK_STATUS.VALID:
						status = this._messages.linkStatusValidMessage;
						break;
					case LinkValidityUtils.LINK_STATUS.INVALID:
						status = this._messages.linkStatusInvalidMessage;
						break;
					default:
						status = this._messages.linkStatusUnknownMessage;
						break;
				}
				
				dojo.create("div", {"class": "status-message"}, detailsDiv).appendChild(document.createTextNode(status));
				var detailsTable = dojo.create("table", {"class": "status-details-table"}, detailsDiv);
				
				if (entry.modified){
					var row = dojo.create("tr", null, detailsTable);
					dojo.create("td", {"class": "label"}, row).appendChild(document.createTextNode(this._messages.setOn));
					dojo.create("td", null, row).appendChild(document.createTextNode(
							DateTimeHelper.getDateTimeDisplayStringFromString(entry.modified)
							));
				}
				if (entry.contributor){
					var row = dojo.create("tr", null, detailsTable);
					dojo.create("td", {"class": "label"}, row).appendChild(document.createTextNode(this._messages.setBy));
					dojo.create("td", null, row).appendChild(document.createTextNode(entry.contributor));
				}
				if (entry.validityDescription){
					dojo.create("div", {"class": "comment-label"}, detailsDiv).appendChild(document.createTextNode(this._messages.comment));
					dojo.create("div", null, detailsDiv).appendChild(document.createTextNode(entry.validityDescription));
				}
                //Only render options to change validity if the permission is present
//                this._projectPermissionsDfd.then(dojo.hitch(this, function(permissions) {
//                    if(permissions.item(rmps.app.ui.internal.common.ProjectCache.ASSERT_LINK_VALIDITY)) {
//                        if (entry.status && (entry.status === LinkValidityUtils.LINK_STATUS.VALID 
//                                     || entry.status === LinkValidityUtils.LINK_STATUS.INVALID 
//                                     || entry.status === LinkValidityUtils.LINK_STATUS.UNKNOWN)){
//                            var containerDiv = null;
//
//
//                            if (this.entry.status !== LinkValidityUtils.LINK_STATUS.VALID){
//                                containerDiv = dojo.create("div", null, detailsDiv);
//                                this._hover.connect(dojo.create("a", {innerHTML: this._messages.markValid}, 
//                                            containerDiv), "onclick", dojo.hitch(this, this._setStatus, LinkValidityUtils.LINK_STATUS.VALID, null));
//                            }
//
//                            if (this.entry.status !== LinkValidityUtils.LINK_STATUS.INVALID){
//                                containerDiv = dojo.create("div", null, detailsDiv);
//                                this._hover.connect(dojo.create("a", {innerHTML: this._messages.markInvalid}, 
//                                            containerDiv), "onclick", dojo.hitch(this, this._setStatus, LinkValidityUtils.LINK_STATUS.INVALID, null));
//                            }
//
//                            if (this.entry.status !== LinkValidityUtils.LINK_STATUS.UNKNOWN){
//                                containerDiv = dojo.create("div", null, detailsDiv);
//                                this._hover.connect(dojo.create("a", {innerHTML: this._messages.markSuspect}, 
//                                            containerDiv), "onclick", dojo.hitch(this, this._setStatus, LinkValidityUtils.LINK_STATUS.UNKNOWN, null));
//                            }
//                        }
//                    }
//                }));
                
			}
			
//		}));

		return container;
	},
	
	//Need to go fetch the full details and then render these in a reasonable way 
	_getFullValidityDetails: function() {
		var postData = [{
			linkType: this.entry.linkType,
			linkUri: this.entry.linkUri,
			sourceConceptId: this.entry.sourceConceptId,
			targetConceptId: this.entry.targetConceptId
		}];
		
		return LinkValidityUtils.getInfo(postData);
	}
	
});
}());
