/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corporation 2013, 2014 All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function InfoContentUtils() {
dojo.provide("rmps.app.ui.internal.util.InfoContentUtils");

dojo.require("dijit.layout.BorderContainer");

dojo.require("rmps.app.ui.internal.dialogs.InfoContent");
dojo.require("rmps.app.ui.internal.dialogs.QuestionDialogContent");

dojo.requireLocalization("rmps.app.ui.internal.dialogs", "InfoContentMessages");
var Messages = dojo.i18n.getLocalization("rmps.app.ui.internal.dialogs", "InfoContentMessages");

dojo.require("jazz.ui.Dialog");

	rmps.app.ui.internal.util.InfoContentUtils = {
		
	    showQuestionDialog: function __showQuestionDialog(title, messageContent, okContent, cancelContent, okFunction, cancelFunction) {
	    	var extraParams = {
	    		message: messageContent,
	    		okMessage: okContent,
	    		cancelMessage: cancelContent,
	    		okFunction: okFunction,
	    		cancelFunction: cancelFunction
	    	};
	    	this.showDialog(rmps.app.ui.internal.dialogs.QuestionDialogContent, title, extraParams);
	    },
	    
	    showDialog: function __showDialog(clazz, title, extraParams, closeHook){
	        var floatingPane;
	        var onOk = dojo.hitch(this, function(){
	            floatingPane.close();
	            floatingPane.destroy();
	        });
	        
	        var onClose = dojo.hitch(this, function(){
	            floatingPane.content.destroy();
	            delete floatingPane.content;
	        });

	        var params = this._getFloatingPaneParams(clazz, title, onOk, onClose, extraParams);
	        if (closeHook) {
	        	params.onClose = closeHook;
	        }
	        floatingPane= new jazz.ui.Dialog(params);

	        var content = params.content;
	        if (content && content.setFocus){
	            content.setFocus();
	        }
	    },

	    //extraParams is optional
	    _getFloatingPaneParams: function __getFloatingPaneParams(clazz, title, contentCloseCallback, dialogCloseCallback, extraParams){
	        var contentParams = {
	            onOk: dojo.hitch(this, contentCloseCallback),
	            onCancel: dojo.hitch(this, contentCloseCallback)
	        };
	        
	        if (extraParams) {
		        for (var param in extraParams) {
		        	contentParams[param] = extraParams[param];
		        }
	        }
	        
	        var content = new clazz(contentParams);

	        var floatingPaneParams = {
	            contentNode: content.domNode,
	            content: content,
	            onClose: dialogCloseCallback
	        };
	        floatingPaneParams.primaryTitle = title;
	        return floatingPaneParams;
	    }
	
	};

}());